package cn.com.qmth.examcloud.core.oe.task.service;

import cn.com.qmth.examcloud.core.oe.task.dao.entity.ExamCaptureEntity;
import cn.com.qmth.examcloud.core.oe.task.service.bean.CalculateFaceCheckResultInfo;
import cn.com.qmth.examcloud.core.oe.task.service.bean.CompareFaceSyncInfo;
import cn.com.qmth.examcloud.core.oe.task.service.bean.ExamCaptureQueueInfo;
import org.json.JSONException;
import org.springframework.transaction.annotation.Transactional;

/**
 * @Description 照片处理结果
 * @Author lideyin
 * @Date 2019/12/11 14:45
 * @Version 1.0
 */
public interface ExamCaptureService {
	void disposeBaiDuFaceLiveness(ExamCaptureQueueInfo examCaptureQueue) throws JSONException;

    @Transactional
    void saveExamCaptureAndDeleteQueue(ExamCaptureQueueInfo examCaptureQueue);

	/**
	 * 同步比较人脸:用于进入考试
	 * @param studentId			学生ID
	 * @param baseFaceToken		学生底照faceToken
	 * @param fileUrl				抓拍照片Url
	 * @return
	 */
	CompareFaceSyncInfo compareFaceSyncByFileUrl(Long studentId, String baseFaceToken, String fileUrl);

	/**
	 * 获取考试抓拍结果
	 * @param examRecordDataId
	 * @param fileName
	 * @return
	 */
	ExamCaptureEntity getExamCaptureResult(Long examRecordDataId, String fileName);
	/**
	 * 处理单个考试抓拍照片数据
	 * @param examCaptureQueueInfo
	 */
	void disposeFaceCompare(ExamCaptureQueueInfo examCaptureQueueInfo) throws JSONException;

	/**
	 * 计算人脸检测结果
	 * @param examRecordDataId
	 * @return
	 */
    CalculateFaceCheckResultInfo calculateFaceCheckResult(Long examRecordDataId);
}
